function xrec = PPXA_Poisson_TextGeom_TV_L1(x,Nx,Mx,z,alphaP,L,T,mup,mum,nu,M,rm,Ml,Mc,cte,cte_app,minC,maxC,niter,nomImage)

% Variation totale
%------------------
L1=2;
L2=2;
L12 = 1;
L22 = 1;
h = [1/2 0 ; 0 -1/2];
H = zeros(Nx,Mx);
H(1:L12,1:L22) = h(L12+1:L1,L22+1:L2);
H(Nx:-1:Nx-L12+1,1:L22) = h(1:L12,L22+1:L2);
H(1:L12,Mx:-1:Mx-L22+1) = h(L12+1:L1,1:L22);
H(Nx:-1:Nx-L12+1,Mx:-1:Mx-L22+1) = h(1:L12,1:L22);
H = fft2(H);

v = [0 1/2; -1/2 0];
V = zeros(Nx,Mx);
V(1:L12,1:L22) = v(L12+1:L1,L22+1:L2);
V(Nx:-1:Nx-L12+1,1:L22) = v(1:L12,L22+1:L2);
V(1:L12,Mx:-1:Mx-L22+1) = v(L12+1:L1,1:L22);
V(Nx:-1:Nx-L12+1,Mx:-1:Mx-L22+1) = v(1:L12,1:L22);
V = fft2(V);


cT = conj(T);
cH = conj(H);
cV = conj(V);
sT = (T.*conj(T)+1);
sH = (H.*conj(H)+1);
sV = (V.*conj(V)+1);   
mHV = H.*conj(V);
mVH = V.*conj(H);
F = 2+nu;

%Determinant
det1 = -F.*sT.*sH.*sV;
det2 = F.*sT.*mHV.*mVH;
det3 = T.*cT.*sH.*sV;
det4 = -T.*cT.*mHV.*mVH;
det5 = H.*sT.*cH.*sV;
det6 = -H.*sT.*cV.*mVH;
det7 = -V.*sT.*cH.*mHV;
det8 = V.*sT.*cV.*sH;
det =  det1 + det2 + det3 + det4 + det5 + det6 + det7 + det8; 

%Cofacteurs de (LL^T)^{-1}

Co11 = sT.*(-sH.*sV+mHV.*mVH);
Co12 = cT.*(-sH.*sV+mHV.*mVH);
Co13 = -sT.*(-cH.*sV+cV.*mVH);
Co14 = sT.*(-cH.*mHV+cV.*sH);

Co21 = T.*(-sH.*sV+mHV.*mVH);
Co22 = -F.*sH.*sV + F.*mHV.*mVH + H.*cH.*sV - H.*cV.*mVH - V.*cH.*mHV + V.*cV.*sH;
Co23 = -T.*(-cH.*sV + cV.*mVH);
Co24 = T.*(-cH.*sV + cV.*sH);

Co31 = sT.*(H.*sV - V.*mHV);
Co32 = cT.*(H.*sV - V.*mHV);
Co33 = -(F.*sT.*sV - T.*cT.*sV - V.*cV.*sT);
Co34 = F.*sT.*mHV - T.*cT.*mHV - H.*cV.*sT;

Co41 = -sT.*(H.*mVH - V.*sH);
Co42 = -cT.*(H.*mVH - V.*sH);
Co43 = F.*sT.*mVH - T.*cT.*mVH - V.*cH.*sT;
Co44 = -(F.*sT.*sH - T.*cT.*sH - H.*cH.*sT);


% ALGORITM
%---------
lambda=1;
gamma=60;

%Functions number
N= 3;    

%Initialization of weigth w
w = zeros(N,1);                                                           
w(1)=1/N;
w(2)=1/N;
w(3)=1/N;

%Initialization of y_i
[wpz,wmz,H1x,H2x,HH1x,HH2x,Gx,Ghx]=dualtreeM2D_freq(z,M,rm);
wpz_vect = 1/nu*cell2vect(wpz,rm,Ml,Mc);
wmz_vect = 1/nu*cell2vect(wmz,rm,Ml,Mc);
y = ones(N,1)*[wpz_vect,wmz_vect,z(:)',z(:)',z(:)',z(:)',z(:)'];
p = zeros(size(y));

ind11 = [1:length(wpz_vect)];
ind12 = [length(wpz_vect)+1:length(wpz_vect)+length(wmz_vect)];
ind2 = [length(wpz_vect)+length(wpz_vect)+1:length(wpz_vect)+length(wmz_vect)+length(z(:)')];
ind3 = [length(wpz_vect)+length(wpz_vect)+length(z(:)')+1:length(wpz_vect)+length(wmz_vect)+2*length(z(:)')];
ind4 = [length(wpz_vect)+length(wpz_vect)+2*length(z(:)')+1:length(wpz_vect)+length(wmz_vect)+3*length(z(:)')];
ind5 = [length(wpz_vect)+length(wpz_vect)+3*length(z(:)')+1:length(wpz_vect)+length(wmz_vect)+4*length(z(:)')];
ind6 = [length(wpz_vect)+length(wpz_vect)+4*length(z(:)')+1:length(wpz_vect)+length(wmz_vect)+5*length(z(:)')]; 


%Initialization of x0
xn = sum((w*ones(1,length(y))).*y);
critere1 = zeros(1,niter);
critere2 = zeros(1,niter);
snr = zeros(1,niter);
dc = zeros(1,niter);
time = zeros(1,niter+1);
time(1)=0;

for n=1:niter

    %Calcul critere
    %--------------
    wp_xn1_cell = vect2cell(xn(ind11),rm,Ml,Mc,Nx);
    wm_xn1_cell = vect2cell(xn(ind12),rm,Ml,Mc,Nx);
    xrec3 = reshape(xn(ind3),Nx,Mx);
    xrec2 = reshape(xn(ind2),Nx,Mx);
    critere1(n) = DKL(z,xrec3,T,alphaP) + sumcoef_l1m(wp_xn1_cell,1,1,mup,cte(1),cte_app) + sumcoef_l1m(wm_xn1_cell,1,1,mum,cte(1),cte_app) +cte(2)*Variation_totale_gen(xrec2,h,v) ;
    xrec1 = idualtreeM2D_freq_deblur(wp_xn1_cell,wm_xn1_cell,rm,H1x,H2x,HH1x,HH2x,Gx,Ghx);
    xrec = xrec1 + xrec2;
    critere2(n) = DKL(z,xrec,T,alphaP) +sumcoef_l1m(wp_xn1_cell,1,1,mup,cte(1),cte_app) + sumcoef_l1m(wm_xn1_cell,1,1,mum,cte(1),cte_app) +cte(2)*Variation_totale_gen(xrec2,h,v) ;
    snr(n) = snrdeblur(x,xrec);
    dc(n) = distance_convexe(xrec,minC,maxC);
    if (mod(n,10)==0)
        fprintf('%d : dc = %3.2f  |  critere = %3.2f |  snr = %3.2f \n',n,dc(n),critere2(n), snr(n));    
    end

    %Proximity operators computation
    %-------------------------------     
    coef(1) = cte(1)*gamma/w(3);
    coef_app = cte_app*gamma/w(3);
    coef(2) = gamma/w(3);
    coef(3) = cte(2)*gamma/w(3);          

    tic; 
    
    ind=1;
    wp_y11_cell = vect2cell(y(ind,ind11),rm,Ml,Mc,Nx);
    wm_y11_cell = vect2cell(y(ind,ind12),rm,Ml,Mc,Nx);  
    Fstar_y11 = idualtreeM2D_freq_deblur(wp_y11_cell,wm_y11_cell,rm,H1x,H2x,HH1x,HH2x,Gx,Ghx);
    Y1 = fft2( Fstar_y11);  
    Y2 = fft2(reshape(y(ind,ind2),Nx,Mx));
    Y3 = fft2(reshape(y(ind,ind3),Nx,Mx));
    Y4 = fft2(reshape(y(ind,ind4),Nx,Mx));                
    Y5 = fft2(reshape(y(ind,ind5),Nx,Mx));
    Y6 = fft2(reshape(y(ind,ind6),Nx,Mx)); 

    LY1 = Y2 + Y1 - Y3;
    LY2 = T.*Y3 - Y4;
    LY3 = H.*Y2 - Y5;
    LY4 = V.*Y2 - Y6;



    LLinvL1 = (Co11.*LY1 +  Co12.*LY2 +    Co13.*LY3 +  Co14.*LY4)./det;
    LLinvL2 = (Co21.*LY1 +  Co22.*LY2 +    Co23.*LY3 +  Co24.*LY4)./det;
    LLinvL3 = (Co31.*LY1 +  Co32.*LY2 +    Co33.*LY3 +  Co34.*LY4)./det;
    LLinvL4 = (Co41.*LY1 +  Co42.*LY2 +    Co43.*LY3 +  Co44.*LY4)./det;     

    tmp1 = real(ifft2(LLinvL1));
    tmp2 = real(ifft2(LLinvL1 + conj(H).*LLinvL3 +conj(V).*LLinvL4 ));
    tmp3 = real(ifft2(-LLinvL1 + conj(T).*LLinvL2 ));
    tmp4 = real(ifft2(-LLinvL2)); 
    tmp5 = real(ifft2(-LLinvL3));                
    tmp6 = real(ifft2(-LLinvL4)); 

    [wp_v1_cell,wm_v1_cell,H1x,H2x,HH1x,HH2x,Gx,Ghx]=dualtreeM2D_freq(reshape(tmp1,Nx,Mx),M,rm);
    p(ind,ind11) = y(ind,ind11) - cell2vect(wp_v1_cell,rm,Ml,Mc);
    p(ind,ind12) = y(ind,ind12) - cell2vect(wm_v1_cell,rm,Ml,Mc);     
    p(ind,ind2) = y(ind,ind2)- tmp2(:)';
    p(ind,ind3) = y(ind,ind3)- tmp3(:)';
    p(ind,ind4) = y(ind,ind4)- tmp4(:)'; 
    p(ind,ind5) = y(ind,ind5)- tmp5(:)';
    p(ind,ind6) = y(ind,ind6)- tmp6(:)';

    ind = 2;  
    delta = 3.1422e+09;
    borne = 200;
    p(ind,ind11) = y(ind,ind11);
    p(ind,ind12) = y(ind,ind12);    
    p(ind,ind2) = y(ind,ind2);
    p(ind,ind3) = projection_boule(y(ind,ind3),delta,borne);
    p(ind,ind4) = y(ind,ind4);         
    p(ind,ind5) = y(ind,ind5);             
    p(ind,ind6) = y(ind,ind6);    


    ind = 3;  
    wpy2_cell = vect2cell(y(ind,ind11),rm,Ml,Mc,Nx);
    wmy2_cell = vect2cell(y(ind,ind12),rm,Ml,Mc,Nx);
    for j=1:rm,
         for ml=1:Ml,
             for mc=1:Mc,
                if (j==rm && ml==1 && mc==1),
                    omegap = coef_app;
                    wpp2_cell{j}{ml}{mc}= mup + prox_soft(wpy2_cell{j}{ml}{mc}-mup,omegap);
                    omegam = coef_app;
                    wmp2_cell{j}{ml}{mc}= mum + prox_soft(wmy2_cell{j}{ml}{mc}-mum,omegam);

                elseif ~isempty(wpy2_cell{j}{ml}{mc})
                    omegap = coef(1) ;
                    wpp2_cell{j}{ml}{mc}= prox_soft(wpy2_cell{j}{ml}{mc},omegap);
                    omegam = coef(1) ;
                    wmp2_cell{j}{ml}{mc}= prox_soft(wmy2_cell{j}{ml}{mc},omegam);

                end
              end
          end
    end         
    p(ind,ind11) = cell2vect(wpp2_cell,rm,Ml,Mc);
    p(ind,ind12) = cell2vect(wmp2_cell,rm,Ml,Mc); 
    p(ind,ind2) = y(ind,ind2); 
    p(ind,ind3) = projection(y(ind,ind3),minC,maxC);
    p(ind,ind4) = prox_poisson(y(ind,ind4),z(:)',alphaP,coef(2));
    [p(ind,ind5),p(ind,ind6)] = prox_tv_simple(y(ind,ind5),y(ind,ind6),coef(3));

    %Update
    %------
    q = sum((w*ones(1,length(y))).*p);

    y = y + lambda*(ones(N,1)*(2*q - xn) - p );

    xn = xn + lambda*(q - xn);
    
    time(n+1) = time(n)+ toc;  
end

figure
subplot(221)
imagesc(x)
axis image off
title('Original');
subplot(222)
imagesc(z)
axis image off
title('Degraded');
subplot(223)
imagesc(xrec1)
axis image off
title('Texture');
subplot(224)
imagesc(xrec2)
axis image off
title('Geometric');
colormap(gray)

figure
subplot(311)
plot(snr)
xlabel('SNR');
title('Texture+Geometry decomposition');
subplot(312)
plot(critere2)
xlabel('Objective function');
subplot(313)
plot(dc)
xlabel('Distance to C');

fprintf('\n\n PPXA Text+Geom:\n');
fprintf('----------\n');
fprintf('time = %5.1f  \n',time(n+1));
fprintf('snr = %3.2f\n',snr(n));
fprintf('ssim = %3.3f\n',ssim(x,xrec));
fprintf('dc = %3.2f  \n',dc(n));

%%%%%%%%%%%%%%%%% SAUVEGARDE DES DONNEES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tit=['TextGeom_Poisson_TV_l1DTT-',nomImage,'-rm=',int2str(rm),'-niter',int2str(niter),'alpha',num2str(alphaP),'L',int2str(L),'gamma',num2str(gamma),'lambda',num2str(lambda),'coef_TV',num2str(cte(2)),'coef_REG',num2str(cte(1)),'coef_App',num2str(cte_app),'.mat'];
save(tit,'x','z','xrec1','xrec2','xrec','snr','critere1','critere2','xn');




